Автор awoo, история, 5 лет назад, По-русски

Привет, Codeforces!

В 22.02.2022 17:35 (Московское время) состоится Educational Codeforces Round 123 (рейтинговый для Div. 2).

Продолжается серия образовательных раундов в рамках инициативы Harbour.Space University! Подробности о сотрудничестве Harbour.Space University и Codeforces можно прочитать в посте.

Этот раунд будет рейтинговым для участников с рейтингом менее 2100. Соревнование будет проводиться по немного расширенным правилам ICPC. Штраф за каждую неверную посылку до посылки, являющейся полным решением, равен 10 минутам. После окончания раунда будет период времени длительностью в 12 часов, в течение которого вы можете попробовать взломать абсолютно любое решение (в том числе свое). Причем исходный код будет предоставлен не только для чтения, но и для копирования.

Вам будет предложено 6 или 7 задач на 2 часа. Мы надеемся, что вам они покажутся интересными.

Задачи вместе со мной придумывали и готовили Адилбек adedalic Далабаев, Владимир vovuh Петров, Иван BledDest Андросов и Максим Neon Мещеряков. Также большое спасибо Михаилу MikeMirzayanov Мирзаянову за системы Polygon и Codeforces.

Удачи в раунде! Успешных решений!

Также от наших друзей и партнёров из Harbour.Space есть сообщение для вас:

Harbour.Space

Привет, Codeforces!

Пришло время для еще одной захватывающей возможности — стипендии от Harbour.Space!

Мы сотрудничаем с различными техкомпаниями, чтобы предложить вам стипендии для получения степени бакалавра или магистра в области компьютерных наук, информатики, кибербезопасности, разработки программного обеспечения и опыта работы в компаниях-партнерах.

Мы ищем позиции младшего и среднего звена в различных областях, таких как:

  • Java Spring/Node.js Back-End разработчик
  • DevOps-инженер
  • Kotlin Web App разработчик
  • React/React Native Front-End разработчик
  • Специалист по кибербезопасности

Требования:

  1. Аттестат о среднем общем образовании при подаче заявки на получение степени бакалавра или диплом бакалавра при подаче заявки на получение степени магистра
  2. Профессиональное владение английским языком
  3. Предыдущий опыт работы обязателен при подаче заявки на получение степени магистра и будет плюсом при подаче заявки на получение степени бакалавра

Не забудьте подать заявку до 13 марта 2022 года, чтобы иметь шанс получить стипендию и снизить плату за подачу заявления.

Подать заявку →

Следите за новостями в LinkedIn, чтобы не упустить новые возможности. А так же загляните в наш Instagram, где мы делимся событиями студенческой жизни и историями успеха наших учеников.

Желаем удачи и до встречи в следующий раз!

Harbour.Space University

UPD: Разбор опубликован

  • Проголосовать: нравится
  • +201
  • Проголосовать: не нравится

»
5 лет назад, скрыть # |
 
Проголосовать: нравится -16 Проголосовать: не нравится

Hoping for a great contest. Good luck and high ratings for everyone.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +4 Проголосовать: не нравится

Its great that cf is arranging two contest in two continuos days ;-;

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +12 Проголосовать: не нравится

Glad to see MVL switching careers to CP and leaving Chess

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +21 Проголосовать: не нравится
Spoiler
»
5 лет назад, скрыть # |
 
Проголосовать: нравится +2 Проголосовать: не нравится

May all who deserve, gain ++ ∆

Spoiler
»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

I'm looking forward to this contest.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +3 Проголосовать: не нравится

Monsters Incoming !

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

looks like the level gap between E and F is too big...

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +32 Проголосовать: не нравится

looks like the gap between E and F is too big...

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

How to solve E?

  • »
    »
    5 лет назад, скрыть # ^ |
     
    Проголосовать: нравится +14 Проголосовать: не нравится

    count the cells which must be missed.

  • »
    »
    5 лет назад, скрыть # ^ |
    ← Rev. 2  
    Проголосовать: нравится +17 Проголосовать: не нравится

    After processing the first $$$i$$$ characters, lets suppose we are at some position $$${x, y}$$$ .

    Assume wlog we have $$$s_{i} = D$$$.

    We clearly can't even reach points with $$$x' \lt x$$$ or $$$y' \lt y$$$, so let's assume we've marked them as unreachable in the previous $$$i - 1$$$ steps.

    If this is the last character, we can clearly reach all points with $$$x' \geq x$$$ and $$$y' \geq y$$$, so we don't need to subtract anything. Otherwise we don't need to worry about points with $$$x' \gt x$$$, since the next position (which will be on row $$$x + 1$$$ since $$$s_{i} = D$$$) is better suited to that task since any repetition from that point will use the same sequence of repetitions, except for one less downward step.

    So that leaves the points to the right on the same row. If the character $$$R$$$, appears $$$k$$$ more times after position $$$i$$$ of the string, then we will go out of the grid trying to access the last $$$k$$$ columns of this row, so they are unreachable. The rest can clearly be reached by repeating the last occurrence of $$$R$$$ before position $$$i$$$.

    So we just need to subtract $$$k$$$ from the answer at this position. Any further position is in a lower row so we won't overcount.

    We can see due to symmetry the same holds for $$$s_i = R$$$ with $$$D$$$ occuring $$$k$$$ more times after position $$$i$$$.

    One last thing to be careful about, is that for the first substring of equal characters, there is no character to move us downward / right to reach those cells perpendicular to our direction of motion, so we always have to subtract $$$n - 1$$$ in that case.

    Solution — 147333480

»
5 лет назад, скрыть # |
← Rev. 2  
Проголосовать: нравится +37 Проголосовать: не нравится

I'm curious how many others just kept randomly shuffling the permutation till they got one that was anti-fibonnaci in B lol.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +22 Проголосовать: не нравится

C harder than D and E

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +31 Проголосовать: не нравится

speeeeed forces. didn't expect this :(

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +22 Проголосовать: не нравится

How to solve F?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Could someone take a look at why my O(N) solution for D is failing with a TLE? Code here

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Logic for C?

  • »
    »
    5 лет назад, скрыть # ^ |
     
    Проголосовать: нравится 0 Проголосовать: не нравится

    First, we will calculate the max sum for each subarray for length i=0,n, We can do this just by 2 simple FOR loops. So now we have an array SubArraySum[], and subArraySum[i] represents the max sum among the ith length subArray. Now to find the best answer when we can add some k elements of value x, we can do this by iterating over the subArraySum array, and for a SubArray of length =i we can increase its value by x*min(k,i).

»
5 лет назад, скрыть # |
← Rev. 2  
Проголосовать: нравится +47 Проголосовать: не нравится

Thanks! Enjoyed the problems, however, don't you guys feel like the difficulty gap between CF div2 rounds and edus has become large? Or is it just me who's good at such problems and it's meant to be this way? Somehow my performance in edus (well, last two) is exponentially better than in normal div2s and i dont remember edus being so friendly even a little while back. i feel one could exploit edus for large rating gains <doublestrike> like i did </doublestrike>.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится -15 Проголосовать: не нравится

finally a good contest :)

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Could someone tell me why my solution is giving TLE for question D link-https://codeforces.me/contest/1644/submission/147348233

  • »
    »
    5 лет назад, скрыть # ^ |
     
    Проголосовать: нравится 0 Проголосовать: не нравится

    you are creating vectors inside the test case loop, n,m can be upto 2e5. doing this vector creation of this much size t(testcases) time, leads to TLE. To solve this you need to create the vectors outside the test case loop and set and unset it

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Can anyone please tell why my code is getting TLE on testcase 6 in ques D.. Acc to me is O(N) solution.As I couldn't find the reason in contest and after it also. My code https://codeforces.me/contest/1644/submission/147349933

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

got the logic of d, but not able to implement how to check two cell visited previous or not?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +31 Проголосовать: не нравится

I guessed the algorithm, but I can't calculate it. :(

»
5 лет назад, скрыть # |
← Rev. 2  
Проголосовать: нравится +1 Проголосовать: не нравится

A — D, were great (didn't read E or F yet).

It's a pity I didn't read D thoroughly and was thinking about a way harder problem (one in which we're not given coordinates of operations — just q)

»
5 лет назад, скрыть # |
 
Проголосовать: нравится -11 Проголосовать: не нравится

I solved 2 Questions. I see no rating increase in my profile.Reason being???

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +3 Проголосовать: не нравится

Thoroughly enjoyed A through D. Wish I had more time to read the rest

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

any hints on how to do B ques?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Can Someone mention a testcase where my submission for C is failing. Submission: Link to Code

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

can anyone please give me some hint about problem c?

»
5 лет назад, скрыть # |
← Rev. 2  
Проголосовать: нравится +15 Проголосовать: не нравится

To users who get Time Limit exceeded at test 6 of problem D (like me, spend almost half an hour to figure it out)

You should not initiate the rows = [-1]*n and cols = [-1]*m, because it is not guaranteed that the sum of m or n do not exceed 2*10^5. You should using dictionary or hashmap instead.

And thanks for testers for setting test case 6, or I will definitely get hacked after the contest.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +7 Проголосовать: не нравится

If you are/were getting a WA/RE verdict on any of the problems from this contest, you can get a small counter example for your submission on cfstress.com

Problems added: "A, B, C, D, E, F".

If you are not able to find a counter example even after changing the parameters, reply to this thread, mentioning the contest_id, problem_index and submission_id.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

who solve C without dp?

Send like an hour on it.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +1 Проголосовать: не нравится

who solved C without dp?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +76 Проголосовать: не нравится

I can't understand why in Problem F the constraint is $$$1 \le n,k \le 2*10^5$$$.

Is the key point of the problem how to calculate Stirling numbers using NTT?

Absolutely this problem should focus on how to find the solution, not how to use polynomial.

This wastes me too much time so I can't solve it in contest.

  • »
    »
    5 лет назад, скрыть # ^ |
     
    Проголосовать: нравится +28 Проголосовать: не нравится

    I was not able to solve it in time either(cause stupid me thought it was impossible to calculate the sum of Stirling numbers fast enough). But since I hate NTT and I like this problem I have upsolved it without NTT in O(n * sqrt(n))147355537
    After some optimizations(147356152) it is now running in 1,5 seconds, wich is 1/4 of TL, so maybe this solution is actually intendent

    • »
      »
      »
      5 лет назад, скрыть # ^ |
       
      Проголосовать: нравится 0 Проголосовать: не нравится

      Will you please explain it ?

      • »
        »
        »
        »
        5 лет назад, скрыть # ^ |
         
        Проголосовать: нравится +10 Проголосовать: не нравится

        1) I've just realized I am damn and solved this problem in O(nlog)(147475186)
        2) My solution is almost same as in the editorial, but I compute ans = sum S(i,1)+S(i,2)..+S(i,k) in O(min(i,k)) with no fft or other techniques. Since S(i,j) = sum(1<=t<=j) C(j,t) * t^i * (-1)^(j+t) / j! we have:
        S(i,1)+S(i,2)+..+S(i,k) = sum(1<=j<=k,1<=t<=j)( t^i * (-1)^(j-t)/((j-t)! * t!) ). Let d = j-t, then
        ans = sum(1<=t<=k,0<=d<=k-t)( (t^i/t!)*((-1)^d / d!) ) iterate over t and sum(0<=d<=k-t) ((-1)^d / d!) can be precomputed

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

i cant even understand the question D, i solved the answer for no of uniques after all operations, my brain found this sub problem easier and got attached to it, soo much more to learn

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +3 Проголосовать: не нравится

Implementation forces

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +1 Проголосовать: не нравится

anyone else who did random shuffle in B :)

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +3 Проголосовать: не нравится

Can Someone give small hints for Problem E.

Make sure to not spoil it for other people.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится -6 Проголосовать: не нравится

Could someone take a look at why my O(N) solution for D is failing with a TLE? Neon https://codeforces.me/contest/1644/submission/147331915

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

How to solve D ???

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +12 Проголосовать: не нравится

ConstraintForces

»
5 лет назад, скрыть # |
 
Проголосовать: нравится -39 Проголосовать: не нравится

I don't think it's reasonable that there weren't constraints on $$$\sum n$$$ and $$$\sum m$$$. Some people (including me) used O(nT) initialization in each testcase, and some of them got hacked, some didn't.

My submission ran about 1300ms so it can't be hacked due to its relatively small constant, but some submissions that ran 1900+ms got hacked because of the fluctuation of the judge.

I don't think it is constant that matters in Codeforces contest. Maybe a TL of 1000ms is more preferable for C++.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +1 Проголосовать: не нравится

Why is my O(q) approach giving tle for d?

https://codeforces.me/contest/1644/submission/147345716

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Did anyone else do a 2-D Dp for C?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +10 Проголосовать: не нравится

solving E 3 minutes after contest finished is really big pain

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

how would u rate b,c problems ?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +1 Проголосовать: не нравится

I think it was a good round.

But it has only ~100 likes.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Didnt like C(too straightforward, no interesting idea), B and D was good though.

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Any hint for E

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Any hint for E

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Thanks for the round!I liked the tasks and they were interesting!

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +1 Проголосовать: не нравится

Was stuck in C for quite some time. Dropping by few hints for whosoever interested

Hint 1
Hint 2
Hint 3
»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Can someone tell me why my solution 147364129 for problem D is getting WA?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +4 Проголосовать: не нравится

 Can someone explain why do I see this contest as unrated?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +17 Проголосовать: не нравится

I am waiting to see what happens if the ratings for this round are not updated before the Div1/Div2 round starts xD

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Auto comment: topic has been updated by awoo (previous revision, new revision, compare).

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Is there any specific reason why ratings of Educational rounds are delayed to update?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

147328156

Can someone help me figure out where my solution is wrong ? Please , Thank you !! (Problem C)

»
5 лет назад, скрыть # |
 
Проголосовать: нравится +10 Проголосовать: не нравится

Huge gap between E and F. XD

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

hi, I got skipped on all my solutions for this round saying that my code to problem c is similar to other codes I'm sure it's not and if it's there must be a coincidence i didn't cheat or use another account the question is basic dp on best sum for length of k

what should i do, how can i speak to someone who can help, i swear i didn't cheat

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

hi, all my solutions got skipped on this round because code c is similar for other's code there must be a coincidence i didn't cheat or use other account to submit my solutions it's basic dp on best sum for len of k how can i speak to someone can help

what should i do ?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Why the difficulty rating of the problems havent been updated yet ?

»
5 лет назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

The apply now link isn't working